var result, request, response, postid, loadresponse, postresponse,
	mood, music, security, groups, moodmenuindex, usecss, posting, LJURL, LJPage,
	dontautoformat, backdate, removecomment, pickw, moodcount, username, password, usejournal,
	year, month, day, hour, minute, anum;

moodmenuindex = -1;
var props = [];
posting = false;

function Init() {
	DisableKeys(true);
	var tbbg = document.defaultView.getComputedStyle(document.getElementById("messagesource"), '').getPropertyValue("background-color");
	document.getElementById("message").contentWindow.document.body.style.backgroundColor = tbbg;
	usecss = opener.usecss;
	postid = window.arguments[0];
	result = opener.result;
	username = opener.username;
	password = opener.password;
	usejournal = opener.usejournal;
	LJURL = opener.LJURL;
	LJPage = opener.LJPage;
	document.getElementById("subject").disabled = true;
	document.getElementById("postoptions").disabled = true;
	document.getElementById("delete").disabled = true;
	document.getElementById("ok").disabled = true;
	document.getElementById("viewpost").disabled = true;

	var messagedeck = document.getElementById("messagedeck");
	messagedeck.selectedIndex = 2;
	if (postid != -1) {
		document.getElementById("loadwhat").value += postid;
	} else {
		document.getElementById("loadwhat").value = "Loading most recent entry...";
	}
	var body;
	body = "mode=getevents&user=" + escape(opener.username) + "&hpassword=" + escape(hexMD5(opener.password)) + "&ver=1";
	body += "&selecttype=one&itemid=" + postid + "&lineendings=unix";
	if (opener.username != opener.usejournal) {
		body += "&usejournal=" + escape(opener.usejournal);
	}
	SendRequest("POST", LJURL, body, SetupPost, StuffedLoad);
}

function SetupPost() {
	loadresponse = request.responseText;
	if (getResponseData("success", loadresponse) == "OK") {
		//do stuff
		ShowPost();
	} else if (getResponseData("success", loadresponse) == "FAIL") {
		var errmsg = getResponseData("errmsg", loadresponse);
		alert(errmsg);
	} else {
		StuffedLoad();
	}
}

function StuffedLoad() {
	alert("Could not connect to the LiveJournal server.\n\nIt may be down, you\'re lagging too much, or your net connection is stuffed. Take your pick.");
	window.close();
}

function ShowPost() {
	var messagedeck = document.getElementById("messagedeck");
	messagedeck.selectedIndex = 0;
	document.getElementById("subject").disabled = false;
	document.getElementById("postoptions").disabled = false;
	document.getElementById("delete").disabled = false;
	document.getElementById("ok").disabled = false;
	document.getElementById("viewpost").disabled = false;
	GetProps();
	MakeBlank();
	DisableKeys(false);
	var midasframe = document.getElementById("message");
	var messagetext = decodeLJText(getResponseData("events_1_event", loadresponse))
	messagetext = messagetext.replace(/\n/gi,"<br>");
	messagetext = FixLJTags(messagetext, true);
	midasframe.contentWindow.document.body.innerHTML = messagetext;
	SetUpMidas();
	document.getElementById("subject").value = decodeLJText(getResponseData("events_1_subject", loadresponse));
}

function GetProps() {
	var propstring = "";
	for (i = 1; i <= getResponseData("prop_count", loadresponse); i++) {
		propstring += decodeLJText(getResponseData("prop_" + i + "_name", loadresponse)) + "\n";
		propstring += decodeLJText(getResponseData("prop_" + i + "_value", loadresponse)) + "\n";
	}
	music = getResponseData("current_music", propstring);
	if (getResponseData("current_moodid", propstring)) {
		mood = getResponseData("current_moodid", propstring);
		for (j = 0; j < result.moods.length; j++) {
			if (result.moods[j].id == mood) {
				moodmenuindex = j;
				break;
			}
		}
	} else {
		mood = getResponseData("current_mood", propstring);
	}
	postid = getResponseData("events_1_itemid", loadresponse);
	anum = getResponseData("events_1_anum", loadresponse);
	dontautoformat = getResponseData("opt_preformatted", propstring);
	removecomment = getResponseData("opt_nocomments", propstring);
	pickw = getResponseData("picture_keyword", propstring);
	backdate = getResponseData("opt_backdated", propstring);
	groups = getResponseData("events_1_allowmask", loadresponse);
	var sec = getResponseData("events_1_security", loadresponse);
	if (sec) {
		if (sec == "usemask") {
			if (parseInt(groups,10) > 1) {
				security = "custom";
			} else {
				security = "friends";
			}
		}
	} else {
		security = "public";
	}
	GetTime();
}

function GetTime() {
	// LJ always returns time in this format, so it should be safe to hardcode...
	var time = getResponseData("events_1_eventtime", loadresponse);
	year = time.substring(0,4);
	month = time.substring(5,7);
	day = time.substring(8,10);
	hour = time.substring(11,13);
	minute = time.substring(14,16);
	var dateformatter = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat);
	var postdate = document.getElementById("postdate");
	postdate.value = "Date posted: " + dateformatter.FormatDateTime("", dateformatter.dateFormatLong, dateformatter.timeFormatNoSeconds, year, month, day, hour, minute, 0);
	var cal = new Date();
	cal.setFullYear(year,month-1);
	UpdateCalendar(cal);
	SetSelected(document.getElementById("day" + day));
}

function SendPost(delpost) {
	subject = document.getElementById("subject").value;
	if (document.getElementById("tabsource").selected) {
		message = document.getElementById("messagesource").value;
	} else {
		message = getIFrameDocument("message").body.innerHTML;
		message = FixLJTags(message, false);
		if (!dontautoformat) {
			message = FixWrapping(message);
		}
	}
	
	// Make sure they've actually posted something before going along and doing everything.
	body = "mode=editevent&user=" + encodeURIComponent(username) + "&hpassword=" + encodeURIComponent(hexMD5(password)) + "&ver=1";
	if ((message.trim() != "") && (!delpost)) {
		body += "&event=" + encodeURIComponent(message);
		body += "&year=" + encodeURIComponent(year) + "&mon=" + encodeURIComponent(month) + "&day=" + encodeURIComponent(day);
		body += "&hour=" + encodeURIComponent(hour) + "&min=" + encodeURIComponent(minute);
	}
	// Check if posting to a different journal.
    if (username != usejournal) {
		body += "&usejournal=" + encodeURIComponent(usejournal);
	}
	
	body += "&itemid=" + postid;
	if (subject) { body += "&subject=" + encodeURIComponent(subject); }
	
	// Ugh. The way LJ works is if you post a mood name instead of ID for one that it has on the server, it won't attach a funky little
	// pic to it. So that's what this whole mood ID thing is.
	if (parseInt(mood,10) > 0) {
		body += "&prop_current_moodid=" + encodeURIComponent(mood);
	} else if (mood) {
		body += "&prop_current_mood=" + encodeURIComponent(mood);
	}
	// Find music.
	if (music) { body += "&prop_current_music=" + encodeURIComponent(music); }
	// Post security. I haven't figured out the code for enabling and disabling checkboxes all over the place on the Security Options page, so
	// groups doesn't work yet, only public/private/friends.
	if ((security == "friends") || (security == "custom")) {
		body += "&security=usemask&allowmask=" + encodeURIComponent(groups);
	} else {
		body += "&security=" + encodeURIComponent(security);
	}
	// For userpics!
	if (pickw) { body += "&prop_picture_keyword=" + encodeURIComponent(pickw); }
	
	if (dontautoformat) { body += "&prop_opt_preformatted=1"; }
	if (removecomment) { body += "&prop_opt_nocomments=1"; }
	if (backdate) { body += "&prop_opt_backdated=1"; }
	
	body += "&lineendings=unix";
	document.getElementById("whereto").value = "Edited post " + postid + " in journal: " + usejournal;
	// Disable everything while its posting...
	document.getElementById("messagedeck").selectedIndex = 1;
	document.getElementById("postoptions").disabled = true;
	document.getElementById("delete").disabled = true;
	document.getElementById("ok").disabled = true;
	document.getElementById("subject").disabled = true;
	document.getElementById("viewpost").disabled = true;
	// Send off the request.
	SendRequest("POST", LJURL, body, Posting, StuffedPost);
}

function StuffedPost() {
	alert("Could not connect to the LiveJournal server.\n\nIt may be down, you\'re lagging too much, or your net connection is stuffed. Take your pick.");
	ResetBoxes();	
}

function Posting() {
	postresponse = request.responseText;
    if (getResponseData("success", postresponse) == "OK") {
		// I have to do it this way because Moz keeps ignoring me when i do window.close inside a function...
		setTimeout("CloseWindow()",1);
		return;
	} else if (getResponseData("success", postresponse) == "FAIL") {
		alert("Error sending post to LiveJournal.\n\n" + getResponseData("errmsg", postresponse));
		ResetBoxes();
		return;
	}
	StuffedPost();
	return;
}

function ResetBoxes() {
	posting = false;
	document.getElementById("subject").disabled = false;
	document.getElementById("postoptions").disabled = false;
	document.getElementById("delete").disabled = false;
	document.getElementById("ok").disabled = false;
	document.getElementById("viewpost").disabled = false;
	document.getElementById("messagedeck").selectedIndex = 0;
}

function CloseWindow() {
	if (opener.name == "dsHistory") {
		opener.setTimeout("SetSelected()",1);
	}
	window.close();
}

function DeletePost() {
	var really = confirm("Are you sure you want to delete this post?");
	if (really) {
		SendPost(true);
	}
}

function ViewPost() {
	var posturl = "/" + ((parseInt(postid,10) * 256) + parseInt(anum)) + ".html";
	OpenJournalPage(posturl);
}